//<clean=none></clean>
#ifndef serverh
#define serverh

#define server_max 100
#define server_no_job 0
#define server_job_ready 1
#define server_job_running 2

#include <time.h>
#include "true_false.h"

struct server globalserver;

struct my_msgbuf {
    long mtype;
    char mtext[200];
};


struct server
{

char command[server_max][200];
char output[server_max][200];
int state[server_max];
int jobs;
int jobs_running;
int cpus;
int fd;
int wd;
int on;
int readconfig;
int min_cpus;
int steel;
int max_run_time;
time_t end_time;
time_t start_time;
};
void server_stop_and_exit();
void server_shut_down(struct server *myserver,char *lock_file);
void server_add_job(struct server *myserver,char *command,char *path);
void print_jobs(struct server *myserver);
void server_init(struct server *myserver);
void server_exe_jobs(struct server *myserver);
void server_job_finished(struct server *myserver,char *job);
int server_run_jobs(struct server *myserver);
double server_get_odes_per_s();
double server_get_jobs_per_s();
void change_cpus(struct server *myserver);
void server_check_wall_clock(struct server *myserver);
void server_update_last_job_time();
#endif
