// General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
// base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
// The model can simulate OLEDs, Perovskite cells, and OFETs.
// 
// Copyright (C) 2008-2020 Roderick C. I. MacKenzie
// All rights reserved.
// 
// https://www.gpvdm.com
// r.c.i.mackenzie at googlemail.com
// 
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the GPVDM nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#define _FILE_OFFSET_BITS 64
#define _LARGEFILE_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>
#define TRUE 1
#define FALSE 0

FILE *header;
char local_name[1000];

int count=0;
void trim(char *scan2,char *scan)
{
int i=0;
int pos=0;
for (i=0;i<strlen(scan);i++)
{
	if ((scan[i]!='\t')&&(scan[i]!=' '))
	{
	scan2[pos]=scan[i];
	pos++;
	}
}
scan2[pos]=0;
}

int strpartcmp(char *in, char *match)
{
int i;
if (strlen(in)<strlen(match)) return -1;
for (i=0;i<strlen(match);i++)
{
if (in[i]!=match[i]) return -1;
}
return 0;
}


char * get_arg_plusone( char* in[],int count,char * find)
{
int i;
static char no[] = "";
for (i=0;i<count;i++)
{
if (strcmp(in[i],find)==0)
{
       if ((i+1)<count)
       {
               return in[i+1];
       }else
       {
               return no;
       }
}
}

return no;
}


int get_arg_plusone_pos( char* in[],int count,char * find)
{
int i;
for (i=0;i<count;i++)
{
if (strcmp(in[i],find)==0)
{
       if ((i+1)<count)
       {
               return i+1;
       }else
       {
               return FALSE;
       }
}
}
return FALSE;
}

char *strstrip(char *s)
{
    size_t size;
    char *end;

    size = strlen(s);

    if (!size)
        return s;

    end = s + size - 1;
    while (end >= s && isspace(*end))
        end--;
    *(end + 1) = '\0';

    while (*s && isspace(*s))
        s++;

    return s;
}

void string_to_data(char * in)
{
int i;
int local=0;
fprintf(header,"unsigned char b%d_%s[] = {\n",count,local_name);
fprintf(header,"0x%x,",(unsigned char)strlen(in));

	for (i=0;i<strlen(in);i++)
	{
	fprintf(header,"0x%x",in[i]^0xab);

	if (i!=(strlen(in)-1))
	{
		fprintf(header,",");
	}

	if (local==5)
	{
		fprintf(header,"\n");
		local=0;
	}

	local++;

	}
fprintf(header,"\n};\n");
count++;
}

int main(int argc, char* argv[])
{
FILE *out=fopen("out.dat","w");


	if (get_arg_plusone_pos( argv,argc,"--in")!=-1)
	{
	}else
	{
		printf("need --in!\n");
		exit(0);
	}
char name[1000];
FILE *in;
char scan[5000];

char scan_out[5000];
int i;
int ii;
int found=FALSE;

strcpy(local_name,get_arg_plusone( argv,argc,"--name"));

sprintf(name,"strings_%s.h",local_name);
fprintf(out,"#include \"%s\"\n",name);
header=fopen(name,"w");


fprintf(header,"#ifndef strings_%s_h\n",local_name);
fprintf(header,"#define strings_%s_h\n",local_name);

in=fopen(get_arg_plusone( argv,argc,"--in"),"r");

int percent=FALSE;
do
{
	strcpy(scan,"");
	fgets(scan, 5000, in);
	for (i=0;i<strlen(scan);i++)
	{
		//printf("scan 2 %c\n",scan[i]);
		if (scan[i]=='"')
		{
			percent=FALSE;

			for (ii=i+1;ii<strlen(scan);ii++)
			{

				if (scan[ii]=='%')
				{
					percent=TRUE;
				}

				if (scan[ii]=='"')
				{
				break;
				//printf("break 1\n");
				}

				//printf("scan 1 %c %d\n",scan[ii],percent);

			}



			if ((ii<strlen(scan))&&(percent==FALSE))
			{
				found=TRUE;
				i++;
				//printf("break 2\n");
				break;
			}else
			{
			i=ii;
			}
		}

	}

	int j;
	int write=FALSE;
	if ((found==TRUE)&&(i!=ii)&&(strpartcmp(scan, "#include")!=0))
	{
		write=TRUE;

		for (j=0;j<i-1;j++)
		{
			scan_out[j]=scan[j];
		}
		scan_out[j]=0;

	}

	if (write==TRUE)
	{
		sprintf(scan_out,"%sdata_to_string(b%d_%s)%s",scan_out,count,local_name,scan+ii+1);
		fprintf(out,"%s\n",scan_out);

		scan[ii]=0;
		string_to_data(scan+i);
	}else
	{
		fprintf(out,"%s",scan);
	}

	found=FALSE;
	//trim(scan2,scan);


}while(!feof(in));

fprintf(header,"#endif\n");

fclose(in);
fclose(header);
fclose(out);
return 0;
}
